#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <tchar.h>
#include <stdlib.h>


#include <locale.h> // wcslen

#include "stdbool.h"
#include "wsq_demo.h"

#include "convert_utf8_to_utf16.c"




#ifndef _UNICODE
#define _UNICODE
#endif
#ifndef UNICODE
#define UNICODE
#endif



int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, INT) {
//INT WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE, LPWSTR, INT) {
	
    g_hInstance = hInstance;
	// Create A Window Class Structure
	WNDCLASSEXW wc;
	wc.cbClsExtra = 0;
	wc.cbSize = sizeof(wc);
	wc.cbWndExtra = 0;
	wc.hbrBackground = GetSysColorBrush(COLOR_BTNFACE);
	wc.hCursor = LoadCursor(NULL,(IDC_ARROW));
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	wc.hInstance = GetModuleHandle(NULL);
	wc.lpfnWndProc = WndProc;
	wc.lpszClassName = g_szWsqClass;
	wc.lpszMenuName = NULL;
	wc.style = CS_VREDRAW|CS_HREDRAW|CS_OWNDC;

	// Register Window Class
	RegisterClassExW(&wc);
	
	RECT rect;
	GetWindowRect(GetDesktopWindow(), &rect);

	// Create a Window
    int top, left;
    left = (rect.right-355)/2; // center Window in screen
    top = (rect.bottom-435)/2; // center Window in screen
	g_hwnd = CreateWindowExW(0, g_szWsqClass, L"WSQ Library Demo", WS_OVERLAPPEDWINDOW, left, top, 355, 435, (HWND)NULL, (HMENU)NULL, (HINSTANCE)wc.hInstance, 0);
	// Drawing area
	g_bitmapWnd = CreateWindowExW(0, L"Static", L"Static", WS_CHILD|WS_VISIBLE|WS_BORDER|SS_BITMAP, 0,0,330,300, g_hwnd,(HMENU)IMG_BITMAP, (HINSTANCE)wc.hInstance, 0); // SS_BITMAP
	if (!g_bitmapWnd) {
       MessageBoxW(0, L"Not create bitmap area", L"Error", 0);
    }
    
	// Create buttons
	// HWND OpenBtn = 
	CreateWindowExW(0, L"BUTTON", L"Open", WS_CHILD|WS_VISIBLE, 10,355,100,33, g_hwnd,(HMENU)BTN_OPEN,NULL,0);

	g_hwndSaveButton = CreateWindowExW(0, L"BUTTON", L"Save", WS_CHILD|WS_VISIBLE, 115,355,100,33, g_hwnd,(HMENU)BTN_SAVE,NULL,0);
	EnableWindow(g_hwndSaveButton, false);

	// HWND RegisterBtn = 
	CreateWindowExW(0, L"BUTTON", L"Register", WS_CHILD|WS_VISIBLE, 220, 317, 100, 33, g_hwnd,(HMENU)BTN_REGISTER,NULL,0);

	// HWND DecodeBtn = 	
	g_hwndDecodeButton = CreateWindowExW(0, L"BUTTON", L"stream->WSQ", WS_CHILD|WS_VISIBLE, 115,317,100,33, g_hwnd,(HMENU)BTN_ENCODE,NULL,0);
	EnableWindow(g_hwndDecodeButton, false);
	
	// HWND EncodeBtn = 
	CreateWindowExW(0, L"BUTTON", L"WSQ->stream", WS_CHILD|WS_VISIBLE, 10,317,100,33, g_hwnd,(HMENU)BTN_DECODE,NULL,0);
	
	ShowWindow(g_hwnd,SW_SHOW);

	// Message Loop
	MSG msg;
	while(GetMessage(&msg,0,0,0)>0) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;
}

bool loadWsqLibrary() {	
	
	if (!g_wsqLibrary) {
		g_wsqLibrary = LoadLibraryW(L"WSQ_library.dll");
	}
	if (!g_wsqLibrary) {
		MessageBoxW(0, L"Cannot load WSQ_library.dll library.", L"Error", 0);
		return false;
	}
	return true;
}

void registerWsq() {
	if (!loadWsqLibrary()) {
		return;
	}
	if (!RegisterWSQ_ptr) {
		RegisterWSQ_ptr = (RegisterWSQ)GetProcAddress(g_wsqLibrary,	"_RegisterWSQ");
	}
	if (!RegisterWSQ_ptr) {
		MessageBoxW(0, L"Unable to get address of function RegisterWSQ in WSQ_library.dll library.", L"Error", 0);
		return;
	}
	
// "RegisterWSQ64.exe" and "WSQ image library (for Windows 64-bit)" were compiled using Microsoft Visual C++ 2008 version compiler.
// If it fails to run then you need to install Microsoft Visual C++ 2008 Redistributable Package (x64).
// The download link is:
// https://www.microsoft.com/en-us/download/details.aspx?id=26368
// Microsoft Visual C++ 2008 Redistributable Package (x64)	
	
	
	RegisterWSQ_ptr();
}




void loadFile() {
	if (!loadWsqLibrary()) {
		return;
	}
	if (!CreateBMPFromFile_ptr) {
		CreateBMPFromFile_ptr = (CreateBMPFromFile)GetProcAddress(g_wsqLibrary, "_CreateBMPFromFile");
	}
	if (!CreateBMPFromFile_ptr) {
		MessageBoxW(0, L"Error", L"Unable to get address of function CreateBMPFromFile in WSQ_library.dll library.", 0);
		return;
	}
	if (!g_bitmapWnd) {
		MessageBoxW(0, L"Unable to create image display object.", L"Error", 0);
		return;
	}


	const wchar_t* strFilter = L"All images\0*.wsq;*.bmp;*.tiff;*.tif;*.jpg;*.jp2;*.jpc;*.jpe;*.jpeg;*.png;*.gif;*.iff;*.ico;*.wmf;"
L"*.emf;*.jfif;*.rle;*.dib;*.win;*.vst;*.vda;*.tga;*.icb;*.fax;*.eps;*.pcx;*.pcc;*.scr; *.rpf;*.rla;*.sgi;"
L"*.rgba;*.rgb;*.bw;*.psd;*.pdd;*.ppm;*.pgm;*.pbm;*.cel;*.pic;*.pcd;*.cut;*.psp\0"
L"FBI Wavelet Scalar Quantization (*.wsq)\0*.wsq\0"
L"Windows bitmaps (*.bmp)\0*.bmp\0"
L"Macintosh TIFF images (*.tiff)\0*.tiff\0"
L"PC TIFF images (*.tif)\0*.tif\0"
L"JPG images (*.jpg)\0*.jpg\0"
L"JPEG-2000 Part-1 (*.jp2)\0*.jp2\0"
L"JPEG-2000 Code Stream (*.jpc)\0*.jpc\0"
L"JPE images (*.jpe)\0*.jpe\0"
L"JPEG images (*.jpeg)\0*.jpeg\0"
L"Portable network graphic images (*.png)\0*.png\0"
L"Compuserve Graphic Interchange Format(*.gif)\0*gif\0"
L"Paintshop Pro images (*.psp)\0*.psp\0"
L"JFIF images (*.jfif)\0*.jfif\0"
L"Run length encoded Windows bitmaps (*.rle)\0*.rle\0"
L"Device independant Windows bitmaps (*.dib)\0*.dib\0"
L"Truevision images (*.win)\0*.win\0"
L"Truevision images (*.vst)\0*.vst\0"
L"Truevision images (*.vda)\0*.vda\0"
L"Truevision images (*.tga)\0*.tga\0"
L"Truevision images (*.icb)\0*.icb\0"
L"GFI fax images (*.fax)\0*.fax\0"
L"Encapsulated Postscript images (*.eps)\0*.eps\0"
L"ZSoft Paintbrush images (*.pcx)\0*.pcx\0"
L"ZSoft Paintbrush images (*.pcc)\0*.pcc\0"
L"Word 5.x screen capture images (*.scr)\0*.scr\0"
L"Alias/Wavefront images (*.rpf)\0*.rpf\0"
L"Alias/Wavefront images (*.rla)\0*.rla\0"
L"SGI true color images (*.sgi)\0*.sgi\0"
L"SGI true color images with alpha (*.rgba)\0*.rgba\0"
L"SGI true color images (*.rgb)\0*.rgb\0"
L"SGI black/white images (*.bw)\0*.bw\0"
L"Photoshop images (*.psd)\0*.psd\0"
L"Photoshop images (*.pdd)\0*.pdd\0"
L"Portable pixel map images (*.ppm)\0*.ppm\0"
L"Portable gray map images (*.pgm)\0*.pgm\0"
L"Portable bitmap images (*.pbm)\0*.pbm\0"
L"Autodesk images (*.cel)\0*.cel\0"
L"Autodesk images (*.pic)\0*.pic\0"
L"Kodak Photo-CD images (*.pcd)\0*.pcd\0"
L"Dr. Halo images (*.cut)\0*.cut\0"
L"Amiga Bitmap Graphic (8 bits)\0*.iff\0"
L"Windows icons (*.ico)\0*.ico\0"
L"Windows metafiles (*.wmf)\0*.wmf\0"
L"Windows enhanced meta files (*.emf)\0*.emf\0\0";


    wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_READONLY;

      if (!GetOpenFileNameW(&ofn)) {
         return ; // cancel open file
      }

 
	  
	g_hBitmap = CreateBMPFromFile_ptr(convert_utf16_to_utf8((char*)szFileName));
	
	
	if (!g_hBitmap) {
		MessageBoxW(0, L"Error loading image", L"Error", 0);
		return;
	}

	SendMessage(g_bitmapWnd, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hBitmap);
	EnableWindow(g_hwndSaveButton, true);
}



void saveFile() {
	if (!loadWsqLibrary()) {
		return;
	}
	if (!SaveBMPToFile_ptr) {
		SaveBMPToFile_ptr = (SaveBMPToFile)GetProcAddress(g_wsqLibrary, "_SaveBMPToFile");
	}
	if (!SaveBMPToFile_ptr) {
		MessageBoxW(0, L"Unable to get address of function SaveBMPToFile in WSQ_library.dll library.", L"Error", 0);
		return;
	}
	if (!g_bitmapWnd) {
		MessageBoxW(0, L"Unable to create image display object.", L"Error", 0);
		return;
	}

	const wchar_t* strFilter = L"WSQ Files (*.wsq)\0*.wsq\0"
L"Windows BMP (*.bmp)\0*.bmp\0"
L"TIFF Files (*.tif)\0*.tif\0"
L"PNG Files (*.png)\0*.png\0"
L"JPEG Files (*.jpg)\0*.jpg\0"
L"Targa Files (*.tga)\0*.tga\0"
L"SGI Files (*.rgb)\0*.rgb\0"
L"JPEG-2000 Part-1 (*.jp2)\0*.jp2\0"
L"JPEG-2000 Code Stream (*.jpc)\0*.jpc\0"
L"PBM - Portable Bitmap Format (*.pbm)\0*.pbm\0"
L"PGM - Portable Graymap Format (*.pgm)\0*.pgm\0"
L"PPM - Portable Pixmap Format (*.ppm)\0*.ppm\0\0";

                            
    wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    if (!GetSaveFileNameW(&ofn)) {
       return ; // cancel open file
    }
    
    HBITMAP bitmap = (HBITMAP)SendMessage(g_bitmapWnd, STM_GETIMAGE, IMAGE_BITMAP, (LPARAM)0);
    if (!bitmap) {
       MessageBoxW(0, L"Unable to get bitmap from view control", L"Error", 0);
       return;
    }
    SaveBMPToFile_ptr(bitmap, convert_utf16_to_utf8((char*)szFileName), ofn.nFilterIndex);
}


void decodeStream() {
	if (!loadWsqLibrary()) {
		return;
	}
	if (!WSQ_decode_stream_ptr) {
		WSQ_decode_stream_ptr = (WSQ_decode_stream)GetProcAddress(g_wsqLibrary, "_WSQ_decode_stream");
	}
	if (!WSQ_decode_stream_ptr) {
		MessageBoxW(0, L"Error", L"Unable to get address of function WSQ_decode_stream in WSQ_library.dll library.", 0);
		return;
	}
	if (!CreateBMPFromWSQByteArray_ptr) {
		CreateBMPFromWSQByteArray_ptr = (CreateBMPFromWSQByteArray)GetProcAddress(g_wsqLibrary, "_CreateBMPFromWSQByteArray");
	}
	if (!CreateBMPFromWSQByteArray_ptr) {
		MessageBoxW(0, L"Error", L"Unable to get address of function CreateBMPFromWSQByteArray in WSQ_library.dll library.", 0);
		return;
	}
	if (!SaveWSQByteArrayToImageFile_ptr) {
		SaveWSQByteArrayToImageFile_ptr = (SaveWSQByteArrayToImageFile)GetProcAddress(g_wsqLibrary, "_SaveWSQByteArrayToImageFile");
	}
	if (!SaveWSQByteArrayToImageFile_ptr) {
		MessageBoxW(0, L"Error", L"Unable to get address of function SaveWSQByteArrayToImageFile in WSQ_library.dll library.", 0);
		return;
	}		
	
	
	const wchar_t* strFilter = L"WSQ Files (*.wsq)\0*.wsq\0\0";
	wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    ofn.Flags = OFN_FILEMUSTEXIST | OFN_READONLY;

    if (!GetOpenFileNameW(&ofn)) {
       return ; // cancel open file
    }

	int handle = _wopen(szFileName, 0);
    if (!handle) {
       MessageBoxW(0, L"Cannot open file", L"Error", 0);
       return;
    }
    int ret = 0;
    //if((ret = _filelength(handle)) < 0) {
    if((ret = filelength(handle)) < 0) {
            MessageBoxW( 0, L"Error: filelength < 0", L"Error", 0 );
    }
    FILE* infp = 0;
	if((infp = _wfopen(szFileName, L"rb")) == (FILE *)NULL) {
                 MessageBoxW( 0, L"Error: open file failed", L"Error", 0 );
             return;
    }
    input_stream_length = ret;
    if (input_data_stream) {
       free(input_data_stream); // no memory leak
    }
    input_data_stream = (unsigned char *)malloc(input_stream_length * sizeof(unsigned char));
    if(input_data_stream == (unsigned char *)NULL) {
       MessageBoxW( 0, L"Error: malloc for input_data_stream failed", L"Error", 0 );
    }
    int n = fread(input_data_stream, sizeof(unsigned char), input_stream_length, infp);
    if(n != input_stream_length) {
         MessageBoxW( 0, L"Error: reading file failed", L"Error", MB_OK );
    }
    fclose(infp);
    close(handle); 
    
    (WSQ_decode_stream_ptr)(input_data_stream, input_stream_length, &output_data_stream, &g_width, &g_height, &g_ppi, &g_comment_text);
    
    //Converts WSQ compressed byte array into HBITMAP for showing on screen
    g_hBitmap = (CreateBMPFromWSQByteArray_ptr)(input_data_stream, input_stream_length);
    // Saves WSQ compressed byte array to an image file.
    //(SaveWSQByteArrayToImageFile_ptr)(input_data_stream, input_stream_length, "C:\\OutputDirectory\\output.jpg", 5);    
    
	
   if(input_data_stream != (unsigned char*)NULL)
   {free(input_data_stream); input_data_stream = (unsigned char*)NULL;}
	
	
	  if (!g_hBitmap) {
		   MessageBoxW(0, L"Error loading image", L"Error", 0);
		   return;
	  }
	  SendMessage(g_bitmapWnd, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)g_hBitmap);    
    
    MessageBoxW(0, L"WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.", L"WSQ image library", 0 );
    EnableWindow(g_hwndDecodeButton, true);
}

void encodeStream() {
	if (!loadWsqLibrary()) {
		return;
	}
	if (!WSQ_encode_stream_ptr) {
		WSQ_encode_stream_ptr = (WSQ_encode_stream)GetProcAddress(g_wsqLibrary, "_WSQ_encode_stream");
	}
	if (!WSQ_encode_stream_ptr) {
		MessageBoxW(0, L"Error", L"Unable to get address of function WSQ_encode_stream in WSQ_library.dll library.", 0);
		return;
	}
	
	const wchar_t* strFilter = L"WSQ Files (*.wsq)\0*.wsq\0\0";
	wchar_t szFileName[MAX_PATH] = { 0 };
    OPENFILENAMEW ofn;
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = 0;
    ofn.hInstance = 0;
    ofn.lpstrFilter = strFilter;
    ofn.nFilterIndex = 1;
    ofn.nMaxFile = MAX_PATH;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = 0;
    ofn.lpstrDefExt= 0;
    ofn.lpstrFile = szFileName;
    
    if (!GetSaveFileNameW(&ofn)) {
       return ; // cancel open file
    }
    
    double bitrate = 0.75;
    int ppi = 500;
    g_comment_text2 = (char *)malloc(32 * sizeof(char));
    g_comment_text2[0] = '\0';
    strcat(g_comment_text2, "Cognaxon");

    
    if(input_data_stream2 != (unsigned char*)NULL) {
        free(input_data_stream2);
        input_data_stream2 = (unsigned char*)NULL;
    }
    input_data_stream2 = (unsigned char *)malloc((g_width*g_height) * sizeof(unsigned char));
    if(input_data_stream2 == (unsigned char *)NULL) {
        MessageBoxW(0, L"Error: malloc for input_data_stream2 failed", L"Error", 0 );
        return;
    }
    
    int row, row2, pixel_number, pixel_number2;
    
    // MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
    for (int y = 0; y < g_height; y++)
    {
        row = g_width * y;
		row2 = g_width * (g_height - y - 1);
        for (int x = 0;  x < g_width; x++)
        {
         pixel_number = row + x;
		 pixel_number2 = row2 + (g_width - x - 1);

         input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
        }
    }
    
    // THE ENCODING OF DECOMPRESSED STREAM INTO WSQ STREAM
    (WSQ_encode_stream_ptr)(input_data_stream2, g_width, g_height, bitrate, ppi, g_comment_text2, &output_data_stream2, &output_stream2_length);
    
    if(g_comment_text2 != NULL)
    {
    free(g_comment_text2);
    g_comment_text2 = (char*) NULL; // this prevents crashing when opening next WSQ image
    }
    
    
	wcscat(szFileName, L".wsq");
    
    FILE* outfp = 0;
    if((outfp = _wfopen(szFileName, L"wb")) == NULL) {
        MessageBoxW(0, L"Error: open file failed", L"Error", 0 );
    }
    unsigned int n = 0;
    if((n = fwrite(output_data_stream2, 1, output_stream2_length, outfp)) != output_stream2_length) {
          MessageBoxW(0, L"Error: write to file failed", L"Error", MB_OK );
    }
    fclose(outfp);

    MessageBoxW(0, L"Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).", L"WSQ image library", 0 );
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam) {
	switch (message) {
	case WM_COMMAND:


		//--------------------------------------------------------------------------
		if (LOWORD(wParam)==BTN_REGISTER) {
			registerWsq();
		}
		//--------------------------------------------------------------------------
		if (LOWORD(wParam)==BTN_OPEN) {
			loadFile();
		}
		//--------------------------------------------------------------------------
		if (LOWORD(wParam)==BTN_SAVE) {
			saveFile();
		}
		//--------------------------------------------------------------------------
		if (LOWORD(wParam)==BTN_DECODE) {
			decodeStream();
		}
		//--------------------------------------------------------------------------
		if (LOWORD(wParam)==BTN_ENCODE) {
			encodeStream();
		}
		break;
 	case WM_DESTROY:
			PostQuitMessage(0);
			break;	
	}
	return DefWindowProc(hWnd,message,wParam,lParam);
}
